"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var path_1 = __importDefault(require("path"));
var typescript_1 = __importDefault(require("typescript"));
var utils_1 = require("./utils");
var visitor_1 = require("./visitor");
/* ****************************************************************************************************************** *
 * Transformer
 * ****************************************************************************************************************** */
function transformer(program, config, _a) {
    var _b;
    var tsInstance = _a.ts;
    if (!tsInstance)
        tsInstance = typescript_1.default;
    var compilerOptions = program.getCompilerOptions();
    var implicitExtensions = utils_1.getImplicitExtensions(compilerOptions);
    var rootDirs = (_b = compilerOptions.rootDirs) === null || _b === void 0 ? void 0 : _b.filter(path_1.default.isAbsolute);
    return function (transformationContext) {
        var tsTransformPathsContext = {
            compilerOptions: compilerOptions,
            config: config,
            elisionMap: new Map(),
            factory: transformationContext.factory,
            implicitExtensions: implicitExtensions,
            program: program,
            rootDirs: rootDirs,
            transformationContext: transformationContext,
            tsInstance: tsInstance,
            tsThreeInstance: utils_1.cast(tsInstance),
        };
        return function (sourceFile) {
            if (!compilerOptions.baseUrl || !compilerOptions.paths)
                return sourceFile;
            var visitorContext = __assign(__assign({}, tsTransformPathsContext), { sourceFile: sourceFile, isDeclarationFile: sourceFile.isDeclarationFile, originalSourceFile: tsInstance.getOriginalSourceFile(sourceFile), getVisitor: function () {
                    return visitor_1.nodeVisitor.bind(this);
                } });
            return tsInstance.visitEachChild(sourceFile, visitorContext.getVisitor(), transformationContext);
        };
    };
}
exports.default = transformer;
