"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.cloneNode = exports.getImplicitExtensions = exports.cast = exports.isBaseDir = exports.isURL = void 0;
var typescript_1 = __importDefault(require("typescript"));
var url_1 = __importDefault(require("url"));
var path_1 = __importDefault(require("path"));
/* ****************************************************************************************************************** *
 * General Utilities & Helpers
 * ****************************************************************************************************************** */
var isURL = function (s) { return !!s && (!!url_1.default.parse(s).host || !!url_1.default.parse(s).hostname); };
exports.isURL = isURL;
var isBaseDir = function (base, dir) { var _a; return ((_a = path_1.default.relative(base, dir)) === null || _a === void 0 ? void 0 : _a[0]) !== "."; };
exports.isBaseDir = isBaseDir;
var cast = function (v) { return v; };
exports.cast = cast;
/**
 * @returns Array of implicit extensions, given CompilerOptions
 */
function getImplicitExtensions(options) {
    var res = [".ts", ".d.ts"];
    var allowJs = options.allowJs, jsx = options.jsx, allowJson = options.resolveJsonModule;
    var allowJsx = !!jsx && jsx !== typescript_1.default.JsxEmit.None;
    allowJs && res.push(".js");
    allowJsx && res.push(".tsx");
    allowJs && allowJsx && res.push(".jsx");
    allowJson && res.push(".json");
    return res;
}
exports.getImplicitExtensions = getImplicitExtensions;
/**
 * Creates a mutable clone of a TS Node (accommodates both TS4+ and earlier versions)
 */
function cloneNode(context, node) {
    var factory = context.factory, tsInstance = context.tsInstance;
    return factory
        ? factory.cloneNode(node)
        : exports.cast(tsInstance).getMutableClone(exports.cast(node));
}
exports.cloneNode = cloneNode;
